Package: wppi
Type: Package
Title: Weighting protein-protein interactions
Version: 1.19.0
Authors@R: c(
    person(
        given = "Ana",
        family = "Galhoz",
        role = c("cre", "aut"),
        email = "ana.galhoz@helmholtz-muenchen.de",
        comment = c(ORCID = "0000-0001-7402-5292")),
    person(
        given = "Denes",
        family = "Turei",
        role = "aut",
        email = "turei.denes@gmail.com",
        comment = c(ORCID = "0000-0002-7249-9379")),
    person(
        given = "Michael",
        family = "P. Menden",
        role = "aut",
        email = "michael.menden@helmholtz-muenchen.de",
        comment = c(ORCID = "0000-0003-0267-5792")),
    #
    # Copyright holders
    person("Albert", "Krewinkel", role = c("ctb", "cph"), 
         comment = "pagebreak Lua filter")
    )
Description: Protein-protein interaction data is essential for omics data
    analysis and modeling. Database knowledge is general, not specific for
    cell type, physiological condition or any other context determining which
    connections are functional and contribute to the signaling. Functional
    annotations such as Gene Ontology and Human Phenotype Ontology might help
    to evaluate the relevance of interactions. This package predicts
    functional relevance of protein-protein interactions based on functional
    annotations such as Human Protein Ontology and Gene Ontology, and
    prioritizes genes based on network topology, functional scores and a path
    search algorithm.
License: MIT + file LICENSE
URL: https://github.com/AnaGalhoz37/wppi
BugReports: https://github.com/AnaGalhoz37/wppi/issues
biocViews: GraphAndNetwork, Network, Pathways, Software, GeneSignaling,
        GeneTarget, SystemsBiology, Transcriptomics, Annotation
Encoding: UTF-8
VignetteBuilder: knitr
Depends: R(>= 4.1)
Imports: dplyr, igraph, logger, methods, magrittr, Matrix, OmnipathR(>=
        2.99.8), progress, purrr, rlang, RCurl, stats, tibble, tidyr
Suggests: knitr, testthat, rmarkdown
RoxygenNote: 7.1.1
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/wppi
git_branch: devel
git_last_commit: 40fc535
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-18
Packaged: 2025-11-19 02:38:50 UTC; biocbuild
Author: Ana Galhoz [cre, aut] (ORCID: <https://orcid.org/0000-0001-7402-5292>),
  Denes Turei [aut] (ORCID: <https://orcid.org/0000-0002-7249-9379>),
  Michael P. Menden [aut] (ORCID:
    <https://orcid.org/0000-0003-0267-5792>),
  Albert Krewinkel [ctb, cph] (pagebreak Lua filter)
Maintainer: Ana Galhoz <ana.galhoz@helmholtz-muenchen.de>

# wppi

wppi is a functional genome-phenotype gene prioritisation tool according to their potential relevance in a disease, based on Gene Ontology 
([GO](http://geneontology.org/)) and Human Phenotype Ontology ([HPO](https://hpo.jax.org/app/)) ontology databases. 

## Description

This package constructs a Protein-Protein Interaction (PPI) network in the neighborhood of user-defined genes of interest from the Omnipath webservice 
(https://omnipathdb.org/) through the **OmnipathR** `R` package. The built PPI is functionally weighted based on topological information (shared neighbors) and 
the functional similarities from GO and HPO ontology databases. The new candidate genes are scored by a Random Walk with Restart algorithm on the predefined 
weighted PPI.

In this repository it is provided the relevant functions to run and customize the workflow.

## Installation
wppi is an available package published on [Bioconductor](http://bioconductor.org/packages/3.15/bioc/html/wppi.html) and [GitHub](https://github.com/AnaGalhoz37/wppi).

The package can be installed using the following commands:

### From Bioconductor (last release)
```{r bioconductor installation, results='hide'}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
    
BiocManager::install("wppi", version = '3.15')

## Development version with the lastest updates
BiocManager::install('wppi', version = 'devel')
```

### From Github
```
require(devtools)
install_github('AnaGalhoz37/wppi')
```

### Dependencies 
The `wppi` package depends on the `OmnipathR` package. Since it relies on
features more recent than the latest Bioconductor version (OmnipathR 2.0.0
in Bioconductor 3.13), until the release of Bioconductor 3.15, it is
recommended to install OmnipathR from git.

```{r bioconductor Omnipath, results='hide'}
require(devtools)
install_github('saezlab/OmnipathR')
```

## Getting started and user cases

We recomment to read our vignette and manual with examples of how to query functions using the **wppi** package.

The **wppi** pipeline can be leveraged for the following cases:

1. The user has a list of known disease related genes, and wants to discover new genes in a PPI proximity based on all available GO and HPO ontology terms.

```{r workflow 1, results='hide'}
# example gene set
genes_interest <- c(
    'ERCC8', 'AKT3', 'NOL3', 'TTK',
    'GFI1B', 'CDC25A', 'TPX2', 'SHE'
)
scores <- score_candidate_genes_from_PPI(genes_interest)
scores
# # A tibble: 295 x 3
#    score gene_symbol uniprot
#    <dbl> <chr>       <chr>
#  1 0.247 KNL1        Q8NG31
#  2 0.247 HTRA2       O43464
#  3 0.247 KAT6A       Q92794
#  4 0.247 BABAM1      Q9NWV8
#  5 0.247 SKI         P12755
#  6 0.247 FOXA2       Q9Y261
#  7 0.247 CLK2        P49760
#  8 0.247 HNRNPA1     P09651
#  9 0.247 HK1         P19367
# 10 0.180 SH3RF1      Q7Z6J0
# # . with 285 more rows
```

2. In addition to a set of genes, the user wants to customize the whole pipeline for a specific phenotype. For example, if interested in diabetes related annotations:

```{r workflow 2, results = 'hide'}
HPO_data <- wppi_hpo_data()
HPO_interest <- unique(dplyr::filter(HPO_data, grepl('Diabetes', Name))$Name)
scores_diabetes <- score_candidate_genes_from_PPI(genes_interest,HPO_interest)
scores
# # A tibble: 295 x 3
#    score gene_symbol uniprot
#    <dbl> <chr>       <chr>
#  1 0.247 KNL1        Q8NG31
#  2 0.247 HTRA2       O43464  
#  3 0.247 KAT6A       Q92794 
#  4 0.247 BABAM1      Q9NWV8 
#  5 0.247 SKI         P12755 
#  6 0.247 FOXA2       Q9Y261 
#  7 0.247 CLK2        P49760 
#  8 0.247 HNRNPA1     P09651 
#  9 0.247 HK1         P19367 
# 10 0.180 SH3RF1      Q7Z6J0 
# # … with 285 more rows
```
![Untitled 7](https://user-images.githubusercontent.com/63655559/117475389-45554400-af5c-11eb-82c3-a47f3a98998e.png)


All previous use cases can be altered to consider different subsets and aspects of GO (e.g., only Biological Processes), or different parameters used for the creation of the weighted PPI and the Random Walk with Restart algorithm.

## Package feedback

To report bugs, ask questions or any feedback, please use the [Github issue page](https://github.com/AnaGalhoz37/wppi/issues). 

#' The wppi package
#'
#' @description
#' The \code{wppi} package calculates context specific scores for genes in
#' the network neighborhood of genes of interest. The context specificity
#' is ensured by the selection of the genes of interest and potentially by
#' using a more relevant subset of the ontology annotations, e.g. selecting
#' only the diabetes related categories. The PPI network and the functional
#' annotations are obtained automatically from public databases, though
#' it's possible to use custom databases. The network is limited to a
#' neighborhood of the genes of interest. The ontology annotations are also
#' filtered to the genes in this subnetwork. Then the adjacency matrix is
#' weighted according to the number of common neighbors and the similarity
#' in functional annotations of each pair of interacting proteins. On this
#' weighted adjacency matrix a random walk with restart is performed. The
#' final score for the genes in the neighborhood is the sum of their scores
#' (probabilities to be visited) in the random walk.
#' The method can be fine tuned by setting the neighborhood range, the
#' restart probability of the random walk and the threshold for the random
#' walk.
#'
#' @examples
#' # Example with a single call:
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' scores <- score_candidate_genes_from_PPI(genes_interest)
#' # The workflow step by step:
#' db <- wppi_data()
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' graph_op <- graph_from_op(db$omnipath)
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' w_adj <- weighted_adj(graph_op_1, db$go, db$hpo)
#' w_rw <- random_walk(w_adj)
#' scores <- prioritization_genes(graph_op_1, w_rw, genes_interest)
#'
#' @author Ana Galhoz \email{ana.galhoz@@helmholtz-muenchen.de} and
#' Denes Turei \email{turei.denes@@gmail.com}
#'
#' @docType package
#' @name wppi
NULL

# Quiet R CMD check about the dots that appear in pipelines
if(getRversion() >= '2.15.1')  utils::globalVariables(c('.'))

#' Setting up the logfile and logging parameters.
#'
#' @importFrom logger INFO log_formatter formatter_glue_or_sprintf
#' @importFrom logger log_threshold log_appender layout_glue_generator
#' @importFrom logger log_layout
#'
#' @noRd
wppi_log_setup <- function(pkgname = 'wppi', threshold = logger::INFO){

    layout_format <-
        paste0(
            '[{format(time, "%Y-%m-%d %H:%M:%S")}] ',
            '[{colorize_by_log_level(level, levelr)}]',
            '{paste0(rep(" ", 7 - nchar(level)), collapse = "")} ',
            '[{ns}] ',
            '{grayscale_by_log_level(msg, levelr)}'
        )

    logger::log_formatter(
        logger::formatter_glue_or_sprintf,
        namespace = pkgname,
    )
    logger::log_threshold(threshold, namespace = pkgname)
    logger::log_appender(logger::appender_console, namespace = pkgname)
    logger::log_layout(
        logger::layout_glue_generator(format = layout_format),
        namespace = pkgname
    )

}


.onLoad <- function(libname, pkgname){

    wppi_log_setup()

}

#' Database knowledge for wppi
#'
#' Retrieves the database knowledge necessary for WPPI directly from the
#' databases. The databases used here are the Human Phenotype Ontology (HPO,
#' \url{https://hpo.jax.org/app/}), Gene Ontology (GO,
#' \url{http://geneontology.org/}) and OmniPath
#' (\url{https://omnipathdb.org/}). The downloads carried out by
#' the OmnipathR package and data required by wppi are extracted from each
#' table.
#'
#' @param GO_slim Character: use a GO subset (slim). If \code{NULL}, the
#'     full GO is used. The most often used slim is called "generic". For
#'     a list of available slims see \code{OmnipathR::go_annot_slim}.
#' @param GO_aspects Character vector with the single letter codes of the
#'     gene ontology aspects to use. By default all three aspects are used.
#'     The aspects are "C": cellular component, "F": molecular function and
#'     "P" biological process.
#' @param GO_organism Character: name of the organism for GO annotations.
#' @param ... Passed to
#'     \code{OmnipathR::import_post_translational_interactions}. With these
#'     options you can customize the network retrieved from OmniPath.
#'
#' @return A list of data frames (tibbles) with database knowledge from HPO,
#'     GO and OmniPath.
#'
#' @details
#' If you use a GO subset (slim), building it at the first time might take
#' around 20 minutes. The result is saved into the cache so next time loading
#' the data from there is really quick.
#' Gene Ontology annotations are available for a few other organisms apart
#' from human. The currently supported organisms are "chicken", "cow", "dog",
#' "human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
#' use \code{wppi} to score PPI networks other than human.
#'
#' @examples
#' # Download all data
#' data_wppi <- wppi_data()
#' # OmniPath
#' omnipath_data <- data_wppi$omnipath
#' # HPO
#' HPO_data <- data_wppi$hpo
#' # GO
#' GO_data <- data_wppi$go
#'
#' @importFrom logger log_info
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_go_data}}}
#'     \item{\code{\link{wppi_hpo_data}}}
#'     \item{\code{\link{wppi_omnipath_data}}}
#' }
wppi_data <- function(
    GO_slim = NULL,
    GO_aspects = c('C', 'F', 'P'),
    GO_organism = 'human',
    ...
){

    log_info('Collecting database knowledge.')

    ### Collect database data
    hpo <- wppi_hpo_data()
    go <- wppi_go_data(GO_slim, GO_aspects, GO_organism)
    omnipath <- wppi_omnipath_data(...)

    log_info('Finished collecting database knowledge.')

    list(
        hpo = hpo,
        go = go,
        omnipath = omnipath
    )

}


#' Retrieves data from Human Phenotype Ontology (HPO)
#'
#' Human Phenotype Ontology (\url{https://hpo.jax.org/app/}), HPO) annotates
#' proteins with phenotypes and diseases.
#'
#' @return A data frame (tibble) with HPO data.
#'
#' @examples
#' hpo <- wppi_hpo_data()
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr select distinct
#' @importFrom OmnipathR hpo_download
#' @export
#' @seealso \code{\link{wppi_data}}
wppi_hpo_data <- function(){

    # NSE vs. R CMD check workaround
    entrez_gene_id <- entrez_gene_symbol <-
    hpo_term_id <- hpo_term_name <- NULL

    OmnipathR::hpo_download() %>%
    select(
        Gene_ID = entrez_gene_id,
        Gene_Symbol = entrez_gene_symbol,
        ID = hpo_term_id,
        Name = hpo_term_name
    ) %>%
    distinct()

}


#' Retrieves data from Gene Ontology (GO)
#'
#' Gene Ontology (\url{http://geneontology.org/}), GO) annotates genes
#' by their function, localization and biological processes.
#'
#' @param slim Character: use a GO subset (slim). If \code{NULL}, the
#'     full GO is used. The most often used slim is called "generic". For
#'     a list of available slims see \code{OmnipathR::go_annot_slim}.
#' @param aspects Character vector with the single letter codes of the
#'     gene ontology aspects to use. By default all three aspects are used.
#'     The aspects are "C": cellular component, "F": molecular function and
#'     "P" biological process.
#' @param organism Character: name of the organism for GO annotations.
#'
#' @return A data frame (tibble) with GO annotation data.
#'
#' @details
#' If you use a GO subset (slim), building it at the first time might take
#' around 20 minutes. The result is saved into the cache so next time loading
#' the data from there is really quick.
#' Gene Ontology annotations are available for a few other organisms apart
#' from human. The currently supported organisms are "chicken", "cow", "dog",
#' "human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
#' use \code{wppi} to score PPI networks other than human.
#'
#' @examples
#' go <- wppi_go_data()
#'
#' @importFrom OmnipathR go_annot_download
#' @importFrom magrittr %>%
#' @importFrom dplyr select
#' @export
#' @seealso \code{\link{wppi_data}}
wppi_go_data <- function(
    slim = NULL,
    aspects = c('C', 'F', 'P'),
    organism = 'human'
){

    # NSE vs. R CMD check workaround
    db_object_symbol <- go_id <- aspect <- NULL

    OmnipathR::go_annot_download(
        slim = slim,
        aspects = aspects,
        organism = organism
    ) %>%
    select(
        Gene_Symbol = db_object_symbol,
        ID = go_id,
        Aspect = aspect
    )

}


#' Protein-protein interaction data from OmniPath
#'
#' OmniPath (\url{https://omnipathdb.org/}) integrates protein-protein
#' interactions (PPI) from more than 30 resources. The network created is 
#' highly customizable by passing parameters 
#' to \code{OmnipathR::import_post_translational_interactions}.
#'
#' @param ... Passed to
#'     \code{OmnipathR::import_post_translational_interactions}.
#'
#' @return A data frame (tibble) with protein-protein interaction data from
#'     OmniPath.
#'
#' @examples
#' omnipath <- wppi_omnipath_data()
#'
#' @importFrom OmnipathR import_post_translational_interactions
#' @importFrom RCurl merge.list
#' @importFrom magrittr %>%
#' @importFrom rlang exec !!!
#' @importFrom dplyr select
#' @export
#' @seealso \code{\link{wppi_data}}
wppi_omnipath_data <- function(...){

    # OmniPath
    omnipath_param <-
        list(...) %>%
        merge.list(list(entity_type = 'protein'))

    OmnipathR::import_post_translational_interactions %>%
    exec(!!!omnipath_param) %>%
    select(seq(10))

}

# Practical functions to create igraph objects, weight Protein-Protein
# Interaction (PPI) networks and prioritize genes in the wppi package.


#' Igraph object from OmniPath network
#'
#' Creation of igraph object from PPI OmniPath database with information
#' regarding proteins and gene symbols.
#'
#' @param op_data Data frame (tibble) of OmniPath PPI interactions from
#'     \code{\link{wppi_omnipath_data}}.
#'
#' @return Igraph PPI graph object with vertices defined by UniProt ID and
#'     Gene Symbol, and edges based on interactions, for all connections in
#'     OmniPath.
#'
#' @examples
#' graph_op <- graph_from_op(wppi_omnipath_data())
#' edges_op <- igraph::E(graph_op)
#' vertices_op <- igraph::V(graph_op)
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr select distinct
#' @importFrom igraph graph_from_data_frame
#' @export
#' @seealso \code{\link{wppi_omnipath_data}}
graph_from_op <- function(op_data) {

    # NSE vs. R CMD check workaround
    source_genesymbol <- target_genesymbol <- target <- source <- NULL

    edges <- op_data %>%
        dplyr::select(-c(source_genesymbol, target_genesymbol))
    node_source <- op_data %>%
        dplyr::select(source, source_genesymbol)
    node_target <- op_data %>%
        dplyr::select(target, target_genesymbol)
    names(node_source) <- c("UniProt_ID", "Gene_Symbol")
    names(node_target) <- c("UniProt_ID", "Gene_Symbol")
    nodes <- rbind(node_source, node_target) %>%
        distinct()
    op_graph <- graph_from_data_frame(
        d = edges,
        vertices = nodes
    )
    return(op_graph)
}


#' Check which genes of interest are or not in OmniPath
#'
#' @param graph_op Igraph object based on OmniPath PPI interactions from
#'     \code{\link{graph_from_op}}.
#' @param gene_set Character vector with known-disease specific genes from
#'     which is built the functional weighted PPI.
#' @param in_network Logical: whether to return the genes in the network or
#'     the missing ones.
#'
#' @return Character vector with genes corresponding to the query.
#'
#' @examples
#' # genes mapped and not mapped in OmniPath
#' graph_op <- graph_from_op(wppi_omnipath_data())
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' genes_mapped <- in_omnipath(graph_op, genes_interest, 1)
#' genes_notmapped <- in_omnipath(graph_op, genes_interest, 0)
#'
#' @importFrom igraph vertex_attr
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_omnipath_data}}}
#'     \item{\code{\link{graph_from_op}}}
#' }
in_omnipath <- function(graph_op, gene_set, in_network = TRUE) {
    idx_vertex_bool <- gene_set %in% vertex_attr(graph_op)$Gene_Symbol
    if (in_network) {
        gene_set[idx_vertex_bool]
    } else {
        gene_set[!idx_vertex_bool]
    }
}


#' Extract PPI subgraph by genes of interest
#'
#' From the igraph object of a PPI network obtained from OmniPath extracts a
#' subnetwork around the provided genes of interest. The size of the graph
#' is determined by the \code{sub_level} parameter, i.e. the maximum number
#' of steps (order) from the genes of interest.
#'
#' @param graph_op Igraph object based on OmniPath PPI interactions from
#'     \code{\link{graph_from_op}}.
#' @param gene_set Character vector of gene symbols. These are the genes of
#'     interest, for example known disease specific genes.
#' @param sub_level Integer larger than 0 defining the order of neighborhood
#'     (number of steps) from the genes of interest. If not specified, the
#'     first-order neighbors are used.
#'
#' @return Igraph graph object with PPI network of given genes of interest
#'     and their x-order degree neighbors.
#'
#' @examples
#' # Subgraphs of first and second order
#' graph_op <- graph_from_op(wppi_omnipath_data())
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' graph_op_2 <- subgraph_op(graph_op, genes_interest, 2)
#'
#' @importFrom igraph vertex_attr induced_subgraph V ego
#' @export
subgraph_op <- function(graph_op, gene_set, sub_level = 1L) {

    # sub_level indicates the neighbor-level of given genes
    idx_mapped <- which(vertex_attr(graph_op)$Gene_Symbol %in% gene_set)
    vertices_mapped <- V(graph_op)[idx_mapped]
    if (sub_level == 0L) {
        op_subgraph <- induced_subgraph(graph_op, vertices_mapped)
    } else {
        new_nodes <- unlist(
            ego(
                graph_op,
                order = sub_level,
                nodes = idx_mapped,
                mode = "all",
                mindist = 0
            )
        )
        op_subgraph <- induced_subgraph(graph_op, new_nodes)
    }

    return(op_subgraph)

}


#' Shared neighbors of connected vertices
#'
#' For each interacting pair of proteins in the PPI network, store the nodes
#' of the common neighbors. This function works for any igraph graph.
#'
#' @param graph_op Igraph object based on OmniPath PPI interactions from
#'     \code{\link{graph_from_op}}.
#'
#' @return Data frame (tibble) with igraph vertex IDs of connected pairs of
#'     vertices (source and target), a list column with the IDs of their
#'     common neighbors, and a column with the number of neighbors.
#'
#' @examples
#' graph_op <- graph_from_op(wppi_omnipath_data())
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' shared_neighbors <- common_neighbors(graph_op_1)
#'
#' @importFrom igraph get.edgelist neighbors
#' @importFrom tibble as_tibble
#' @importFrom purrr map2 map_int
#' @importFrom dplyr mutate filter
#' @importFrom magrittr %>%
#' @export
#' @seealso \code{\link{graph_from_op}}
common_neighbors <- function(graph_op) {

    # NSE vs. R CMD check workaround
    nr_neighbors <- NULL

    graph_op %>%
    get.edgelist(names = FALSE) %>%
    `colnames<-`(c('source', 'target')) %>%
    as_tibble %>%
    mutate(
        neighbors = map2(
            .$source,
            .$target,
            function(i, j){
                intersect(
                    neighbors(graph_op, i),
                    neighbors(graph_op, j)
                )
            }
        ),
        nr_neighbors = map_int(neighbors, length)
    ) %>%
    filter(nr_neighbors != 0L)

}


#' Weighted adjacency matrix
#'
#' Converts adjacency to weighted adjacency using network topology
#' information (shared neighbors between connected nodes via
#' \code{\link{common_neighbors}}) integrated with genome and phenotype
#' factors from GO and HPO annotation terms (functionality computed by
#' \code{\link{functional_annot}}). At the end, the weighted adjacency
#' matrix is normalized by column.
#'
#' @param graph_op Igraph object based on OmniPath PPI interactions from
#'     \code{\link{graph_from_op}}.
#' @param GO_data Data frame with GO annotations as provided by
#'     \code{\link{wppi_go_data}}.
#' @param HPO_data Data frame with HPO annotations as provided by
#'     \code{\link{wppi_hpo_data}}.
#'
#' @return Weighted adjacency matrix based on network topology and functional
#'     similarity between interacting proteins/genes based on ontology
#'     databases.
#'
#' @examples
#' db <- wppi_data()
#' GO_data <- db$go
#' HPO_data <- db$hpo
#' # Genes of interest
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' # Graph object with PPI 
#' graph_op <- graph_from_op(db$omnipath)
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' # Filter ontology data
#' GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
#' HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
#' # Weighted adjacency
#' w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)
#'
#' @importFrom igraph vertex_attr vcount ecount
#' @importFrom progress progress_bar
#' @importFrom purrr walk2
#' @importFrom magrittr %>% %<>%
#' @importFrom Matrix .__C__dgTMatrix colSums
#' @importFrom methods as
#' @importFrom tidyr replace_na
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{random_walk}}}
#'     \item{\code{\link{prioritization_genes}}}
#'     \item{\code{\link{common_neighbors}}}
#'     \item{\code{\link{graph_from_op}}}
#'     \item{\code{\link{subgraph_op}}}
#'     \item{\code{\link{score_candidate_genes_from_PPI}}}
#'     \item{\code{\link{wppi_go_data}}}
#'     \item{\code{\link{wppi_hpo_data}}}
#' }
weighted_adj <- function(
    graph_op,
    GO_data,
    HPO_data) {

    log_info('Calculating weighted adjacency matrix.')

    # creating the adjacency matrix and the weight matrices
    adj_data <-
        graph_op %>%
        igraph::as_adjacency_matrix(sparse = TRUE) %>%
        as('dgTMatrix')

    matrix_neighbors <- matrix_weights <- 0L * adj_data

    # checking and preprocessing annotation databases
    if(is.null(GO_data)){
        go_msg <- 'not using GO'
    } else {
        GO_data <- filter_annot_with_network(GO_data, graph_op)
        GO_data <- process_annot(GO_data)
        go_msg <- annot_summary_msg(GO_data)
    }
    if(is.null(HPO_data)){
        hpo_msg <- 'not using HPO'
    } else {
        HPO_data <- filter_annot_with_network(HPO_data, graph_op)
        HPO_data <- process_annot(HPO_data)
        hpo_msg <- annot_summary_msg(HPO_data)
    }

    log_info(
        'Graph size: %d nodes and %d edges; %s; %s.',
        vcount(graph_op),
        ecount(graph_op),
        go_msg,
        hpo_msg
    )

    # all the genes in the PPI
    genes_op <- vertex_attr(graph_op)$Gene_Symbol

    # loop to weight PPI based on annotation databases
    pb <- progress_bar$new(
        total = sum(adj_data != 0L),
        format = '  Weighted adjacency matrix [:bar] :percent eta: :eta'
    )
    
    adj_i <- adj_data@i + 1
    adj_j <- adj_data@j + 1 
    
    for (w in 1:length(adj_i)) {
      i <- adj_i[w]
      j <- adj_j[w]
      
      pb$tick()
      
      gene_i <- genes_op[i]
      gene_j <- genes_op[j]
      
      matrix_weights[i, j] <-
        `if`(
          is.null(GO_data),
          0L,
          functional_annot(GO_data, gene_i, gene_j)
        ) +
        `if`(
          is.null(HPO_data),
          0L,
          functional_annot(HPO_data, gene_i, gene_j)
        )
    }

    neighbors_data <- common_neighbors(graph_op)

    if(nrow(neighbors_data) != 0L){
        for (i in seq(nrow(neighbors_data))) {
            x <- neighbors_data[i, ]
            matrix_neighbors[x[[1]], x[[2]]] <- x[[4]]
        }
    }

    # normalization by column
    matrix_weights %<>%
    `+`(matrix_neighbors) %>%
    sweep(2, colSums(.), FUN = "/")

    # for zero divisions
    matrix_weights@x %<>% replace_na(0)

    log_info('Finished calculating weighted adjacency matrix.')

    return(matrix_weights)
}


#' Random Walk with Restart (RWR)
#'
#' RWR on the normalized weighted adjacency matrix.
#' The RWR algorithm estimates each protein/gene relevance based on the
#' functional similarity of genes and disease/phenotype, and the topology
#' of the network. This similarity score between nodes measures how closely
#' two proteins/genes are related in a network. Thus, enabling to identify
#' which candidate genes are more related to our given genes of interest.
#'
#' @param weighted_adj_matrix Matrix object corresponding to the weighted
#'     adjacency from \code{\link{weighted_adj}}.
#' @param restart_prob Positive value between 0 and 1 defining the restart
#'     probability parameter used in the RWR algorithm. If not specified, 0.4
#'     is the default value.
#' @param threshold Positive value depicting the threshold parameter in the
#'     RWR algorithm. When the error between probabilities is smaller than the
#'     threshold defined, the algorithm stops. If not specified, 1e-5 is
#'     the default value.
#'
#' @return Matrix of correlation/probabilities for the functional
#'     similarities for all proteins/genes in the network.
#'
#' @examples
#' db <- wppi_data()
#' GO_data <- db$go
#' HPO_data <- db$hpo
#' # Genes of interest
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' # Graph object with PPI 
#' graph_op <- graph_from_op(db$omnipath)
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' # Filter ontology data
#' GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
#' HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
#' # Weighted adjacency
#' w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)
#' # Random Walk with Restart
#' w_rw <- random_walk(w_adj)
#'
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{weighted_adj}}}
#'     \item{\code{\link{prioritization_genes}}}
#'     \item{\code{\link{score_candidate_genes_from_PPI}}}
#' }
random_walk <- function(
    weighted_adj_matrix,
    restart_prob = 0.4,
    threshold = 1e-5) {

    log_info(
        paste0(
            'Performing random walk with restart ',
            '(restart probablilty: %g, threshold: %g, number of genes: %d).'
        ),
        restart_prob,
        threshold,
        ncol(weighted_adj_matrix)
    )

    matrix_rw <- 0L * weighted_adj_matrix
    nr_proteins <- ncol(matrix_rw)
    vector0 <- matrix(0, nr_proteins, 1)
    vector_prob0 <- matrix(1 / nr_proteins, nr_proteins, 1)

    pb <- progress_bar$new(
        total = nr_proteins,
        format = '  Random walk [:bar] :percent eta: :eta'
    )

    for (i in seq(nrow(matrix_rw))) {
        pb$tick()
        start_vector <- vector0
        start_vector[i] <- 1
        q_previous <- vector_prob0
        q_next <-
            (1 - restart_prob) *
            (weighted_adj_matrix %*% q_previous) +
            restart_prob * start_vector

        while (any((q_next - q_previous)^2 > threshold)) {
            q_previous <- q_next
            q_next <-
                (1 - restart_prob) *
                (weighted_adj_matrix %*% q_previous) +
                restart_prob *
                start_vector
        }

        matrix_rw[i, ] <- q_next
    }

    return(matrix_rw)
}


#' Candidate genes prioritization
#'
#' Ranks candidate genes based on correlation with the given seed
#' genes of interest. For this, the source proteins/genes (i.e. starting
#' nodes) are reduced to the candidate genes and the target proteins/genes
#' (i.e. end nodes) to the given genes of interest. Each candidate gene
#' score is defined by the sum of its correlations towards the known
#' disease-related genes.
#'
#' @param graph_op Igraph object based on OmniPath PPI interactions from
#'     \code{\link{graph_from_op}}.
#' @param prob_matrix Matrix object with correlations/probabilities of the
#'     all nodes in the network from \code{\link{random_walk}}.
#' @param genes_interest Character vector with known-disease specific genes.
#' @param percentage_genes_ranked Positive integer (range between 0 and 100)
#'     specifying the percentage (%) of the total candidate genes in the
#'     network returned in the output. If not specified, the score of all the
#'     candidate genes is delivered.
#'
#' @return Data frame with the ranked candidate genes based on the functional
#'     score inferred from given ontology terms, PPI and Random Walk with
#'     Restart parameters.
#'
#' @examples
#' db <- wppi_data()
#' GO_data <- db$go
#' HPO_data <- db$hpo
#' # Genes of interest
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' # Graph object with PPI 
#' graph_op <- graph_from_op(db$omnipath)
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' # Filter ontology data
#' GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
#' HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
#' # Weighted adjacency
#' w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)
#' # Random Walk with Restart
#' w_rw <- random_walk(w_adj)
#' # Ranked candidate genes
#' scores <- prioritization_genes(graph_op_1, w_rw, genes_interest)
#'
#' @importFrom igraph vertex_attr vcount
#' @importFrom magrittr %>% %<>%
#' @importFrom dplyr arrange desc filter
#' @importFrom tibble tibble
#' @importFrom logger log_info
#' @importFrom stats quantile
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{graph_from_op}}}
#'     \item{\code{\link{weighted_adj}}}
#'     \item{\code{\link{random_walk}}}
#'     \item{\code{\link{score_candidate_genes_from_PPI}}}
#' }
prioritization_genes <- function(
    graph_op,
    prob_matrix,
    genes_interest,
    percentage_genes_ranked = 100) {

    log_info(
        paste0(
            'Calculating WPPI gene scores ',
            '(genes of interest: %d, genes in network: %d).'
        ),
        length(genes_interest),
        vcount(graph_op)
    )

    # NSE vs. R CMD check workaround
    score <- NULL

    percentage_genes_ranked %<>% `/`(100) %>% min(1)

    genes_op <- vertex_attr(graph_op)$Gene_Symbol
    genes_bool <- genes_op %in% genes_interest

    # filter rows for all genes except the ones of interest,
    # filter column with only genes of interest
    prob_matrix_reduced <- prob_matrix[!genes_bool, genes_bool]

    # get score for each row gene by summing all probabilities of the row
    genes_candidate <- genes_op[!genes_bool]
    proteins_candidate <- vertex_attr(graph_op)$name[!genes_bool]

    tibble(
        score = if(is.null(dim(prob_matrix_reduced))) 
            prob_matrix_reduced 
        else apply(prob_matrix_reduced, 1, sum),
        gene_symbol = genes_candidate,
        uniprot = proteins_candidate
    ) %>%
    arrange(desc(score)) %>%
    filter(
        score >= quantile(score, 1 - percentage_genes_ranked)
    )

}

#' The full WPPI workflow
#'
#' The wppi package implements a prioritization of genes according to their
#' potential relevance in a disease or other experimental or physiological
#' condition. For this it uses a PPI network and functional annotations. A
#' protein-protein interactions (PPI) in the neighborhood of the genes of
#' interest are weighted according to the number of common neighbors of
#' interacting partners and the similarity of their functional annotations.
#' The PPI networks are obtained using the OmniPath
#' (\url{https://omnipathdb.org/}) resource and functionality is deduced
#' using the Gene Ontology (GO, \url{http://geneontology.org/}) and Human
#' Phenotype Ontology (HPO, \url{https://hpo.jax.org/app/}) ontology
#' databases. To score the candidate genes, a Random Walk with Restart
#' algorithm is applied on the weighted network.
#'
#' @param genes_interest Character vector of gene symbols with genes known
#'     to be related to the investigated disease or condition.
#' @param HPO_interest Character vector with Human Phenotype Ontology (HPO)
#'     annotations of interest from which to construct the functionality (for
#'     a list of available annotations see the `Name` column in the data
#'     frame provided by \code{\link{wppi_hpo_data}}). If not specified, all
#'     the annotations available in the HPO database will be used.
#' @param percentage_output_genes Positive integer (range between 0 and 100)
#'     specifying the percentage (\%) of the total candidate genes in the
#'     network returned in the output. If not specified, the score of all the
#'     candidate genes is delivered.
#' @param graph_order Integer larger than zero: the neighborhood range
#'     counted as steps from the genes of interest. These genes, also called
#'     candidate genes, together with the given genes of interest define the
#'     Protein-Protein Interaction (PPI) network used in the analysis. If not
#'     specified, the first order neighbors are used.
#' @param GO_annot Logical: use the Gene Ontology (GO) annotation database
#'     to weight the PPI network. The default is to use it.
#' @param GO_slim Character: use a GO subset (slim). If \code{NULL}, the
#'     full GO is used. The most often used slim is called "generic". For
#'     a list of available slims see \code{OmnipathR::go_annot_slim}.
#' @param GO_aspects Character vector with the single letter codes of the
#'     gene ontology aspects to use. By default all three aspects are used.
#'     The aspects are "C": cellular component, "F": molecular function and
#'     "P" biological process.
#' @param GO_organism Character: name of the organism for GO annotations.
#' @param HPO_annot Logical: use the Human Phenotype Ontology (HPO)
#'     annotation database to weight the PPI network. The default is to use
#'     it.
#' @param restart_prob_rw Numeric: between 0 and 1, defines the restart
#'     probability parameter used in the Random Walk with Restart algorithm.
#'     The default value is 0.4.
#' @param threshold_rw Numeric: the threshold parameter in the Random Walk
#'     with Restart algorithm. When the error between probabilities is
#'     smaller than the threshold, the algorithm stops. The default is 1e-5.
#' @param databases Database knowledge as produced by \code{\link{wppi_data}}.
#' @param ... Passed to
#'     \code{OmnipathR::import_post_translational_interactions}. With these
#'     options you can customize the network retrieved from OmniPath.
#'
#' @return Data frame with the ranked candidate genes based on the functional
#'     score inferred from given ontology terms, PPI and Random Walk with
#'    Restart parameters.
#'
#' @details
#' If you use a GO subset (slim), building it at the first time might take
#' around 20 minutes. The result is saved into the cache so next time loading
#' the data from there is really quick.
#' Gene Ontology annotations are available for a few other organisms apart
#' from human. The currently supported organisms are "chicken", "cow", "dog",
#' "human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
#' use \code{wppi} to score PPI networks other than human.
#'
#' @examples
#' # example gene set
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' # example HPO annotations set
#' hpo <- wppi_hpo_data()
#' HPO_interest <- unique(
#'     dplyr::filter(hpo, grepl("Diabetes", .data$Name))$Name
#' )
#' # Score 1st-order candidate genes
#' new_genes_diabetes <-
#'     score_candidate_genes_from_PPI(
#'         genes_interest = genes_interest,
#'         HPO_interest = HPO_interest,
#'         percentage_output_genes = 10,
#'         graph_order = 1)
#' new_genes_diabetes
#' # # A tibble: 30 x 3
#' #    score gene_symbol uniprot
#' #    <dbl> <chr>       <chr>
#' #  1 0.247 KNL1        Q8NG31
#' #  2 0.247 HTRA2       O43464
#' #  3 0.247 KAT6A       Q92794
#' #  4 0.247 BABAM1      Q9NWV8
#' #  5 0.247 SKI         P12755
#' # # . with 25 more rows
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr filter
#' @importFrom igraph vertex_attr E V
#' @importFrom logger log_fatal log_info log_success
#' @importFrom rlang %||%
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_data}}}
#'     \item{\code{\link{weighted_adj}}}
#'     \item{\code{\link{random_walk}}}
#'     \item{\code{\link{prioritization_genes}}}
#' }
score_candidate_genes_from_PPI <- function(
    genes_interest,
    HPO_interest = NULL,
    percentage_output_genes = 100,
    graph_order = 1,
    GO_annot = TRUE,
    GO_slim = NULL,
    GO_aspects = c('C', 'F', 'P'),
    GO_organism = 'human',
    HPO_annot = TRUE,
    restart_prob_rw = 0.4,
    threshold_rw = 1e-5,
    databases = NULL,
    ...
) {

    # NSE vs. R CMD check workaround
    Name <- NULL

    if(!is.vector(genes_interest) || !is.character(genes_interest)) {
        msg <- '`genes_interest` must be a character vector.'
        log_fatal(msg)
        stop(msg)
    }

    if (is.null(graph_order)) {
        # set as default to use the first order neighbors of the graph
        graph_order <- 1
        log_info('Using first order degree neighbors PPI network.')
    } else if(graph_order <= 0){
        msg <- 'A graph order bigger than zero needs to be provided.'
        log_fatal(msg)
        stop(msg)
    }

    log_info('Executing WPPI workflow.')

    # import data object
    data_info <-
        databases %||%
        wppi_data(
            GO_slim = GO_slim,
            GO_aspects = GO_aspects,
            GO_organism = GO_organism,
            ...
        )

    if (!is.null(HPO_interest)) {
        HPO_data <- data_info$hpo %>% filter(Name %in% HPO_interest)
    } else {
        HPO_data <- data_info$hpo
        log_info('Using all HPO annotations available.')
    }

    # graph object from PPI data
    graph_op <- graph_from_op(op_data = data_info$omnipath)

    # build ith-order graph based on genes of interest
    sub_graph <- subgraph_op(
        graph_op = graph_op,
        gene_set = genes_interest,
        sub_level = graph_order
    )

    # subset GO info based on PPI
    GO_data_sub <- `if`(
        GO_annot,
        filter_annot_with_network(
            data_annot = data_info$go,
            graph_op = sub_graph
        ),
        NULL
    )

    # subset HPO info based on PPI
    HPO_data_sub <- `if`(
        HPO_annot,
        filter_annot_with_network(
            data_annot = HPO_data,
            graph_op = sub_graph
        ),
        NULL
    )

    # weight PPI based on annotations
    weighted_adj_sub <- weighted_adj(
        graph_op = sub_graph,
        GO_data = GO_data_sub,
        HPO_data = HPO_data_sub
    )

    # random walk algorithm on weighted PPI
    random_walk_sub <- random_walk(
        weighted_adj_matrix = weighted_adj_sub,
        restart_prob = restart_prob_rw,
        threshold = threshold_rw
    )

    # compute and rank scores of candidate genes based on given genes
    genes_ranked_sub <- prioritization_genes(
        graph_op = sub_graph,
        prob_matrix = random_walk_sub,
        genes_interest = genes_interest,
        percentage_genes_ranked = percentage_output_genes
    )

    log_success('WPPI workflow completed.')

    return(genes_ranked_sub)

}

#' Processing of ontology annotations
#'
#' Ontology databases such as Gene Ontology
#' (GO, \url{http://geneontology.org/}) and Human Phenotype Ontology
#' (HPO, \url{https://hpo.jax.org/app/}) provide important genome and disease
#' functional annotations of genes. These combined allow to build a
#' connection between proteins/genes and phenotype/disease. This function
#' aggregates information in the GO and HPO ontology datasets.
#'
#' @param data_annot Data frame (tibble) of GO or HPO datasets from
#'     \code{\link{wppi_data}}, \code{\link{wppi_go_data}} or 
#'     \code{\link{wppi_hpo_data}}.
#'
#' @return A list of four elements: 1) "term_size" a list which serves as a
#'     lookup table for size (number of genes) for each ontology term; 2) 
#'     "gene_term" a list to look up terms by gene symbol; 3) "annot" the 
#'     original data frame (\code{data_annot}); 4) "total_genes" the number of 
#'     genes annotated in the ontology dataset.
#'
#' @examples
#' hpo_raw <- wppi_hpo_data()
#' hpo <- process_annot(hpo_raw)
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr group_by count summarize
#' @importFrom logger log_fatal log_info
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_data}}}
#'     \item{\code{\link{wppi_go_data}}}
#'     \item{\code{\link{wppi_hpo_data}}}
#' }
process_annot <- function(data_annot) {

    # NSE vs. R CMD check workaround
    ID <- Gene_Symbol <- NULL

    if(
        !'ID' %in% names(data_annot) ||
        !'Gene_Symbol' %in% names(data_annot)
    ){
        msg <- 'Annotations must have ID and Gene_Symbol columns.'
        log_fatal(msg)
        stop(msg)
    }

    log_info(
        'Preprocessing annotations (%s).',
        which_ontology_database(data_annot)
    )

    list(
        term_size =
            data_annot %>%
            count(ID) %>%
            {`names<-`(as.list(.$n), .$ID)},
        gene_term =
            data_annot %>%
            group_by(Gene_Symbol) %>%
            summarize(terms = list(ID)) %>%
            {`names<-`(as.list(.$terms), .$Gene_Symbol)},
        annot = data_annot,
        total_genes = count_genes(data_annot)
    )

}


#' For an ontology annotation table tells the name of the ontology database
#'
#' @param db Ontology annotation table. Must have a column called `ID`.
#' @param long Logical: return the full name or the abbreviation.
#'
#' @return Character: the name of the ontology database. "Unknown" if the
#'     database is not GO neither HPO.
#'
#' @importFrom dplyr case_when
#' @noRd
which_ontology_database <- function(db, long = TRUE){

    x <- substr(db$ID[1], 1, 2)
    case_when(
        x == 'GO' &  long ~ 'Gene Ontology',
        x == 'GO' & !long ~ 'GO',
        x == 'HP' &  long ~ 'Human Phenotype Ontology',
        x == 'HP' & !long ~ 'HPO',
        TRUE              ~ 'Unknown'
    )

}


#' A summary message with key numbers about an annotation database
#'
#' @param db A preprocessed annotation database as produced by
#'     \code{\link{process_annot}}.
#'
#' @noRd
annot_summary_msg <- function(db){

    sprintf(
        '%s: %d terms, %d genes, %d annotations',
        which_ontology_database(db$annot, long = FALSE),
        length(db$term_size),
        db$total_genes,
        nrow(db$annot)
    )

}


#' Number of total genes in an ontology database
#'
#' @param data_annot Data frame (tibble) of GO or HPO datasets from
#'     \code{\link{wppi_go_data}} or \code{\link{wppi_hpo_data}}.
#'
#' @return Number of total unique genes in each ontology database.
#'
#' @examples
#' go <- wppi_go_data()
#' count_genes(go)
#' # [1] 19712
#'
#' @importFrom magrittr %>%
#' @importFrom dplyr pull n_distinct
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_go_data}}}
#'     \item{\code{\link{wppi_hpo_data}}}
#' }
count_genes <- function(data_annot) {

    # NSE vs. R CMD check workaround
    Gene_Symbol <- NULL

    data_annot %>%
    pull(Gene_Symbol) %>%
    n_distinct

}


#' Filter ontology datasets using PPI network object
#'
#' @param data_annot Data frame (tibble) of GO or HPO datasets from
#'     \code{\link{wppi_go_data}} or \code{\link{wppi_hpo_data}}.
#' @param graph_op Igraph graph object obtained from built OmniPath PPI of
#'     genes of interest and x-degree neighbors.
#'
#' @return Data frame (tibble) of GO or HPO datasets filtered based on
#'     proteins available in the igraph object.
#'
#' @examples
#' # Get GO database
#' GO_data <- wppi_go_data()
#' # Create igraph object based on genes of interest and first neighbors
#' genes_interest <-
#'     c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
#' graph_op <- graph_from_op(wppi_omnipath_data())
#' graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
#' # Filter GO data
#' GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
#'
#' @importFrom igraph vertex_attr
#' @importFrom magrittr %>%
#' @importFrom dplyr filter distinct
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{wppi_go_data}}}
#'     \item{\code{\link{wppi_hpo_data}}}
#'     \item{\code{\link{graph_from_op}}}
#' }
filter_annot_with_network <- function(data_annot, graph_op) {

    # NSE vs. R CMD check workaround
    Gene_Symbol <- NULL

    genes_op <- vertex_attr(graph_op)$Gene_Symbol

    data_annot %>%
    filter(Gene_Symbol %in% genes_op) %>%
    # should not be necessary
    # gene-annotation pairs are supposed to be unique
    distinct()

}


#' Functional similarity score based on ontology
#'
#' Functional similarity between two genes in ontology databases (GO or HPO).
#' Each pair of interacting proteins in the PPI graph network, is
#' quantified the shared annotations between them using the Fisher's combined
#' probability test (\url{https://doi.org/10.1007/978-1-4612-4380-9_6}). This
#' is based on the number of genes annotated in each shared ontology term and
#' the total amount of unique genes available in the ontology database.
#'
#' @param annot Processed annotation data as provided by
#'     \code{\link{process_annot}}.
#' @param gene_i String with the gene symbol in the row of the adjacency
#'     matrix.
#' @param gene_j String with the gene symbol in the column of the adjacency
#'     matrix.
#'
#' @return Numeric value with GO/HPO functional similarity between given
#'     pair of proteins.
#'
#' @examples
#' hpo <- wppi_hpo_data()
#' hpo <- process_annot(hpo)
#' hpo_score <- functional_annot(hpo, 'AKT1', 'MTOR')
#' # [1] 106.9376
#'
#' @export
#' @seealso \itemize{
#'     \item{\code{\link{process_annot}}}
#'     \item{\code{\link{weighted_adj}}}
#' }
functional_annot <- function(annot, gene_i, gene_j) {

    if (
        !gene_i %in% names(annot$gene_term) ||
        !gene_j %in% names(annot$gene_term)
    ){
        return(0)
    }

    shared_terms <- intersect(
        annot$gene_term[[gene_i]],
        annot$gene_term[[gene_j]]
    )

    `if`(
        length(shared_terms) == 0L,
        0,
        sum(-2 * log(
            unlist(annot$term_size[shared_terms]) /
            annot$total_genes
        ))
    )

}

---
title: >-
  Context specific functional scores for protein-protein interaction networks
author:
- name: Ana Galhoz
  affiliation: hmgu
  email: ana.galhoz@helmholtz-muenchen.de
  correspondance: yes
- name: Denes Turei
  affiliation: unihd
institute:
- hmgu: Helmholtz Zentrum Muenchen
- unihd: Institute for Computational Biomedicine, Heidelberg University
output:
  html_document:
    toc: yes
    toc_depth: '4'
    df_print: paged
  BiocStyle::html_document:
    number_sections: yes
    toc: yes
    toc_depth: 4
    pandoc_args:
    - --lua-filter=scholarly-metadata.lua
    - --lua-filter=author-info-blocks.lua
  pdf_document:
    number_sections: yes
    toc: yes
    toc_depth: 4
    pandoc_args:
    - --lua-filter=scholarly-metadata.lua
    - --lua-filter=author-info-blocks.lua
package: wppi
abstract: |
  The `wppi` package calculates context specific scores for genes in
  the network neighborhood of genes of interest. The context specificity
  is ensured by the selection of the genes of interest and potentially by
  using a more relevant subset of the ontology annotations, e.g. selecting
  only the diabetes related categories. The PPI network and the functional
  annotations are obtained automatically from public databases, though
  it's possible to use custom databases. The network is limited to a user defined
  neighborhood of the genes of interest. The ontology annotations are also
  filtered to the genes in this subnetwork. Then the adjacency matrix is
  weighted according to the number of common neighbors and the similarity
  in functional annotations of each pair of interacting proteins. On this
  weighted adjacency matrix a random walk with returns is performed. The
  final score for the genes in the neighborhood is the sum of their scores
  (probabilities to be visited) in the random walk.
  The method can be fine tuned by setting the neighborhood range, the
  restart probability of the random walk and the threshold for the random
  walk.
vignette: |
  %\VignetteIndexEntry{WPPI workflow}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
fig_width: 9
fig_height: 7
---

```{r suppress-progressbars, echo=FALSE}
options(progress_enabled = FALSE, width = 80)
```

# Dependencies

The `wppi` package depends on the `OmnipathR` package. Since it relies on
features more recent than the latest Bioconductor version (OmnipathR 2.0.0
in Bioconductor 3.12), until the release of Bioconductor 3.13, it is
recommended to install OmnipathR from git.

# Complete workflow in a single call

The `score_candidate_genes_from_PPI` function executes the full wppi workflow.
The only mandatory input is a set of genes of interest. As a return, an ordered
table with the similarity scores of the new genes within the neighbourhood of 
the genes of interest is provided. A higher score stands for a higher 
functional similarity between this new gene and the given ones. 

```{r workflow, results='hide'}
library(wppi)
# example gene set
genes_interest <- c(
    'ERCC8', 'AKT3', 'NOL3', 'TTK',
    'GFI1B', 'CDC25A', 'TPX2', 'SHE'
)
scores <- score_candidate_genes_from_PPI(genes_interest)
scores
# # A tibble: 295 x 3
#    score gene_symbol uniprot
#    <dbl> <chr>       <chr>
#  1 0.247 KNL1        Q8NG31
#  2 0.247 HTRA2       O43464
#  3 0.247 KAT6A       Q92794
#  4 0.247 BABAM1      Q9NWV8
#  5 0.247 SKI         P12755
#  6 0.247 FOXA2       Q9Y261
#  7 0.247 CLK2        P49760
#  8 0.247 HNRNPA1     P09651
#  9 0.247 HK1         P19367
# 10 0.180 SH3RF1      Q7Z6J0
# # . with 285 more rows
```

# Workflow step by step

## Database knowledge

The database knowledge is provided by `wppi_data`. By default all directed
protein-protein interactions are used from OmniPath. By passing various
options the network can be customized. See more details in the documentation
of the `OmnipathR` package, especially the
`import_post_translational_interactions` function. For example, to use only
the literature curated interactions one can use the `datasets = 'omnipath'`
parameter:

```{r database-knowledge-omnipath}
omnipath_data <- wppi_omnipath_data(datasets = 'omnipath')
```

The `wppi_data` function retrieves all database data at once. Parameters to
customize the network can be passed directly to this function.

```{r database-knowledge, results='hide'}
db <- wppi_data(datasets = c('omnipath', 'kinaseextra'))
names(db)
# [1] "hpo"      "go"       "omnipath" "uniprot"
```

Optionally, the Human Phenotype Ontology (HPO) annotations relevant in the
context can be selected. For example, to select the annotations related to
diabetes:

```{r database-knowledge-hpo}
# example HPO annotations set
HPO_data <- wppi_hpo_data()
HPO_interest <- unique(dplyr::filter(HPO_data, grepl('Diabetes', Name))$Name)
```

## Converting the interactions to an igraph graph object

To work further with the interactions we first convert it to an `igraph`
graph object:

```{r omnipath-graph}
graph_op <- graph_from_op(db$omnipath)
```

## Subgraph from the neighborhood of genes of interest

Then we select a subgraph around the genes of interest. The size of the
subgraph is determined by the range of this neighborhood (`sub_level`
argument for the `subgraph_op` function).

```{r neighborhood-subnetwork, results='hide'}
graph_op_1 <- subgraph_op(graph_op, genes_interest)
igraph::vcount(graph_op_1)
# [1] 256
```

## Weighted adjacency matrix

The next step is to assign weights to each interaction. The weights are
calculated based on the number of common neighbors and the similarities of
the annotations of the interacting partners.

```{r weighted-adjacency-matrix}
w_adj <- weighted_adj(graph_op_1, db$go, db$hpo)
```

## Random walk

The random walk with restarts algorithm uses the edge weights to score the
overall connections between pairs of genes. The result takes into accound
also the indirect connections, integrating the information in the graph
topology.

```{r random-walk}
w_rw <- random_walk(w_adj)
```

## Scoring proteins

At the end we can summarize the scores for each protein, taking the sum of
all adjacent connections. The resulted table provides us a list of proteins
prioritized by their predicted importance in the context of interest
(disease or condition).

```{r scoring-proteins}
scores <- prioritization_genes(graph_op_1, w_rw, genes_interest)
scores
# # A tibble: 249 x 3
#    score gene_symbol uniprot
#    <dbl> <chr>       <chr>
#  1 0.251 HTRA2       O43464 
#  2 0.251 KAT6A       Q92794 
#  3 0.251 BABAM1      Q9NWV8 
#  4 0.251 SKI         P12755 
#  5 0.251 CLK2        P49760 
#  6 0.248 TUBB        P07437 
#  7 0.248 KNL1        Q8NG31 
#  8 0.189 SH3RF1      Q7Z6J0 
#  9 0.189 SRPK2       P78362 
# 10 0.150 CSNK1D      P48730 
# # . with 239 more rows
```

## Network visualization 

The top genes in the first order neighborhood of the genes of interest can be 
visualized in the PPI network:

```{r fig1,dpi = 300, echo=FALSE, eval = FALSE, fig.cap="PPI network 
visualization of genes of interest (blue nodes) and their first neighbor with 
similarity scores (green nodes). "}
idx_neighbors <- which(!V(graph_op_1)$Gene_Symbol %in% genes_interest)
cols <- rep("lightsteelblue2",vcount(graph_op_1))
cols[idx_neighbors] <- "#57da83"
scores.vertex <- rep(1,vcount(graph_op_1))
scores.vertex[idx_neighbors] <- 
8*scores[na.omit(match(V(graph_op_1)$Gene_Symbol,scores$gene_symbol)),]$score
par(mar=c(0.1,0.1,0.1,0.1))
plot(graph_op_1,vertex.label = ifelse(scores.vertex>=1,V(graph_op_1)$Gene_Symbol,NA),  
layout = layout.fruchterman.reingold,vertex.color=cols,
vertex.size = 7*scores.vertex,edge.width = 0.5,edge.arrow.mode=0,
vertex.label.font = 1, vertex.label.cex = 0.45)
```
```{r fig_knitr,echo=TRUE,eval = FALSE}
library(knitr)
knitr::include_graphics("../figures/fig1.png")
```



# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_data.R
\name{wppi_data}
\alias{wppi_data}
\title{Database knowledge for wppi}
\usage{
wppi_data(
  GO_slim = NULL,
  GO_aspects = c("C", "F", "P"),
  GO_organism = "human",
  ...
)
}
\arguments{
\item{GO_slim}{Character: use a GO subset (slim). If \code{NULL}, the
full GO is used. The most often used slim is called "generic". For
a list of available slims see \code{OmnipathR::go_annot_slim}.}

\item{GO_aspects}{Character vector with the single letter codes of the
gene ontology aspects to use. By default all three aspects are used.
The aspects are "C": cellular component, "F": molecular function and
"P" biological process.}

\item{GO_organism}{Character: name of the organism for GO annotations.}

\item{...}{Passed to
\code{OmnipathR::import_post_translational_interactions}. With these
options you can customize the network retrieved from OmniPath.}
}
\value{
A list of data frames (tibbles) with database knowledge from HPO,
    GO and OmniPath.
}
\description{
Retrieves the database knowledge necessary for WPPI directly from the
databases. The databases used here are the Human Phenotype Ontology (HPO,
\url{https://hpo.jax.org/app/}), Gene Ontology (GO,
\url{http://geneontology.org/}) and OmniPath
(\url{https://omnipathdb.org/}). The downloads carried out by
the OmnipathR package and data required by wppi are extracted from each
table.
}
\details{
If you use a GO subset (slim), building it at the first time might take
around 20 minutes. The result is saved into the cache so next time loading
the data from there is really quick.
Gene Ontology annotations are available for a few other organisms apart
from human. The currently supported organisms are "chicken", "cow", "dog",
"human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
use \code{wppi} to score PPI networks other than human.
}
\examples{
# Download all data
data_wppi <- wppi_data()
# OmniPath
omnipath_data <- data_wppi$omnipath
# HPO
HPO_data <- data_wppi$hpo
# GO
GO_data <- data_wppi$go

}
\seealso{
\itemize{
    \item{\code{\link{wppi_go_data}}}
    \item{\code{\link{wppi_hpo_data}}}
    \item{\code{\link{wppi_omnipath_data}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_app.R
\name{score_candidate_genes_from_PPI}
\alias{score_candidate_genes_from_PPI}
\title{The full WPPI workflow}
\usage{
score_candidate_genes_from_PPI(
  genes_interest,
  HPO_interest = NULL,
  percentage_output_genes = 100,
  graph_order = 1,
  GO_annot = TRUE,
  GO_slim = NULL,
  GO_aspects = c("C", "F", "P"),
  GO_organism = "human",
  HPO_annot = TRUE,
  restart_prob_rw = 0.4,
  threshold_rw = 1e-05,
  databases = NULL,
  ...
)
}
\arguments{
\item{genes_interest}{Character vector of gene symbols with genes known
to be related to the investigated disease or condition.}

\item{HPO_interest}{Character vector with Human Phenotype Ontology (HPO)
annotations of interest from which to construct the functionality (for
a list of available annotations see the `Name` column in the data
frame provided by \code{\link{wppi_hpo_data}}). If not specified, all
the annotations available in the HPO database will be used.}

\item{percentage_output_genes}{Positive integer (range between 0 and 100)
specifying the percentage (\%) of the total candidate genes in the
network returned in the output. If not specified, the score of all the
candidate genes is delivered.}

\item{graph_order}{Integer larger than zero: the neighborhood range
counted as steps from the genes of interest. These genes, also called
candidate genes, together with the given genes of interest define the
Protein-Protein Interaction (PPI) network used in the analysis. If not
specified, the first order neighbors are used.}

\item{GO_annot}{Logical: use the Gene Ontology (GO) annotation database
to weight the PPI network. The default is to use it.}

\item{GO_slim}{Character: use a GO subset (slim). If \code{NULL}, the
full GO is used. The most often used slim is called "generic". For
a list of available slims see \code{OmnipathR::go_annot_slim}.}

\item{GO_aspects}{Character vector with the single letter codes of the
gene ontology aspects to use. By default all three aspects are used.
The aspects are "C": cellular component, "F": molecular function and
"P" biological process.}

\item{GO_organism}{Character: name of the organism for GO annotations.}

\item{HPO_annot}{Logical: use the Human Phenotype Ontology (HPO)
annotation database to weight the PPI network. The default is to use
it.}

\item{restart_prob_rw}{Numeric: between 0 and 1, defines the restart
probability parameter used in the Random Walk with Restart algorithm.
The default value is 0.4.}

\item{threshold_rw}{Numeric: the threshold parameter in the Random Walk
with Restart algorithm. When the error between probabilities is
smaller than the threshold, the algorithm stops. The default is 1e-5.}

\item{databases}{Database knowledge as produced by \code{\link{wppi_data}}.}

\item{...}{Passed to
\code{OmnipathR::import_post_translational_interactions}. With these
options you can customize the network retrieved from OmniPath.}
}
\value{
Data frame with the ranked candidate genes based on the functional
    score inferred from given ontology terms, PPI and Random Walk with
   Restart parameters.
}
\description{
The wppi package implements a prioritization of genes according to their
potential relevance in a disease or other experimental or physiological
condition. For this it uses a PPI network and functional annotations. A
protein-protein interactions (PPI) in the neighborhood of the genes of
interest are weighted according to the number of common neighbors of
interacting partners and the similarity of their functional annotations.
The PPI networks are obtained using the OmniPath
(\url{https://omnipathdb.org/}) resource and functionality is deduced
using the Gene Ontology (GO, \url{http://geneontology.org/}) and Human
Phenotype Ontology (HPO, \url{https://hpo.jax.org/app/}) ontology
databases. To score the candidate genes, a Random Walk with Restart
algorithm is applied on the weighted network.
}
\details{
If you use a GO subset (slim), building it at the first time might take
around 20 minutes. The result is saved into the cache so next time loading
the data from there is really quick.
Gene Ontology annotations are available for a few other organisms apart
from human. The currently supported organisms are "chicken", "cow", "dog",
"human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
use \code{wppi} to score PPI networks other than human.
}
\examples{
# example gene set
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
# example HPO annotations set
hpo <- wppi_hpo_data()
HPO_interest <- unique(
    dplyr::filter(hpo, grepl("Diabetes", .data$Name))$Name
)
# Score 1st-order candidate genes
new_genes_diabetes <-
    score_candidate_genes_from_PPI(
        genes_interest = genes_interest,
        HPO_interest = HPO_interest,
        percentage_output_genes = 10,
        graph_order = 1)
new_genes_diabetes
# # A tibble: 30 x 3
#    score gene_symbol uniprot
#    <dbl> <chr>       <chr>
#  1 0.247 KNL1        Q8NG31
#  2 0.247 HTRA2       O43464
#  3 0.247 KAT6A       Q92794
#  4 0.247 BABAM1      Q9NWV8
#  5 0.247 SKI         P12755
# # . with 25 more rows

}
\seealso{
\itemize{
    \item{\code{\link{wppi_data}}}
    \item{\code{\link{weighted_adj}}}
    \item{\code{\link{random_walk}}}
    \item{\code{\link{prioritization_genes}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{in_omnipath}
\alias{in_omnipath}
\title{Check which genes of interest are or not in OmniPath}
\usage{
in_omnipath(graph_op, gene_set, in_network = TRUE)
}
\arguments{
\item{graph_op}{Igraph object based on OmniPath PPI interactions from
\code{\link{graph_from_op}}.}

\item{gene_set}{Character vector with known-disease specific genes from
which is built the functional weighted PPI.}

\item{in_network}{Logical: whether to return the genes in the network or
the missing ones.}
}
\value{
Character vector with genes corresponding to the query.
}
\description{
Check which genes of interest are or not in OmniPath
}
\examples{
# genes mapped and not mapped in OmniPath
graph_op <- graph_from_op(wppi_omnipath_data())
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
genes_mapped <- in_omnipath(graph_op, genes_interest, 1)
genes_notmapped <- in_omnipath(graph_op, genes_interest, 0)

}
\seealso{
\itemize{
    \item{\code{\link{wppi_omnipath_data}}}
    \item{\code{\link{graph_from_op}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{common_neighbors}
\alias{common_neighbors}
\title{Shared neighbors of connected vertices}
\usage{
common_neighbors(graph_op)
}
\arguments{
\item{graph_op}{Igraph object based on OmniPath PPI interactions from
\code{\link{graph_from_op}}.}
}
\value{
Data frame (tibble) with igraph vertex IDs of connected pairs of
    vertices (source and target), a list column with the IDs of their
    common neighbors, and a column with the number of neighbors.
}
\description{
For each interacting pair of proteins in the PPI network, store the nodes
of the common neighbors. This function works for any igraph graph.
}
\examples{
graph_op <- graph_from_op(wppi_omnipath_data())
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
shared_neighbors <- common_neighbors(graph_op_1)

}
\seealso{
\code{\link{graph_from_op}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{subgraph_op}
\alias{subgraph_op}
\title{Extract PPI subgraph by genes of interest}
\usage{
subgraph_op(graph_op, gene_set, sub_level = 1L)
}
\arguments{
\item{graph_op}{Igraph object based on OmniPath PPI interactions from
\code{\link{graph_from_op}}.}

\item{gene_set}{Character vector of gene symbols. These are the genes of
interest, for example known disease specific genes.}

\item{sub_level}{Integer larger than 0 defining the order of neighborhood
(number of steps) from the genes of interest. If not specified, the
first-order neighbors are used.}
}
\value{
Igraph graph object with PPI network of given genes of interest
    and their x-order degree neighbors.
}
\description{
From the igraph object of a PPI network obtained from OmniPath extracts a
subnetwork around the provided genes of interest. The size of the graph
is determined by the \code{sub_level} parameter, i.e. the maximum number
of steps (order) from the genes of interest.
}
\examples{
# Subgraphs of first and second order
graph_op <- graph_from_op(wppi_omnipath_data())
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
graph_op_2 <- subgraph_op(graph_op, genes_interest, 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_data.R
\name{wppi_omnipath_data}
\alias{wppi_omnipath_data}
\title{Protein-protein interaction data from OmniPath}
\usage{
wppi_omnipath_data(...)
}
\arguments{
\item{...}{Passed to
\code{OmnipathR::import_post_translational_interactions}.}
}
\value{
A data frame (tibble) with protein-protein interaction data from
    OmniPath.
}
\description{
OmniPath (\url{https://omnipathdb.org/}) integrates protein-protein
interactions (PPI) from more than 30 resources. The network created is 
highly customizable by passing parameters 
to \code{OmnipathR::import_post_translational_interactions}.
}
\examples{
omnipath <- wppi_omnipath_data()

}
\seealso{
\code{\link{wppi_data}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Annot_functions.R
\name{process_annot}
\alias{process_annot}
\title{Processing of ontology annotations}
\usage{
process_annot(data_annot)
}
\arguments{
\item{data_annot}{Data frame (tibble) of GO or HPO datasets from
\code{\link{wppi_data}}, \code{\link{wppi_go_data}} or 
\code{\link{wppi_hpo_data}}.}
}
\value{
A list of four elements: 1) "term_size" a list which serves as a
    lookup table for size (number of genes) for each ontology term; 2) 
    "gene_term" a list to look up terms by gene symbol; 3) "annot" the 
    original data frame (\code{data_annot}); 4) "total_genes" the number of 
    genes annotated in the ontology dataset.
}
\description{
Ontology databases such as Gene Ontology
(GO, \url{http://geneontology.org/}) and Human Phenotype Ontology
(HPO, \url{https://hpo.jax.org/app/}) provide important genome and disease
functional annotations of genes. These combined allow to build a
connection between proteins/genes and phenotype/disease. This function
aggregates information in the GO and HPO ontology datasets.
}
\examples{
hpo_raw <- wppi_hpo_data()
hpo <- process_annot(hpo_raw)

}
\seealso{
\itemize{
    \item{\code{\link{wppi_data}}}
    \item{\code{\link{wppi_go_data}}}
    \item{\code{\link{wppi_hpo_data}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_data.R
\name{wppi_go_data}
\alias{wppi_go_data}
\title{Retrieves data from Gene Ontology (GO)}
\usage{
wppi_go_data(slim = NULL, aspects = c("C", "F", "P"), organism = "human")
}
\arguments{
\item{slim}{Character: use a GO subset (slim). If \code{NULL}, the
full GO is used. The most often used slim is called "generic". For
a list of available slims see \code{OmnipathR::go_annot_slim}.}

\item{aspects}{Character vector with the single letter codes of the
gene ontology aspects to use. By default all three aspects are used.
The aspects are "C": cellular component, "F": molecular function and
"P" biological process.}

\item{organism}{Character: name of the organism for GO annotations.}
}
\value{
A data frame (tibble) with GO annotation data.
}
\description{
Gene Ontology (\url{http://geneontology.org/}), GO) annotates genes
by their function, localization and biological processes.
}
\details{
If you use a GO subset (slim), building it at the first time might take
around 20 minutes. The result is saved into the cache so next time loading
the data from there is really quick.
Gene Ontology annotations are available for a few other organisms apart
from human. The currently supported organisms are "chicken", "cow", "dog",
"human", "pig" and "uniprot_all". If you disable \code{HPO_annot} you can
use \code{wppi} to score PPI networks other than human.
}
\examples{
go <- wppi_go_data()

}
\seealso{
\code{\link{wppi_data}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{graph_from_op}
\alias{graph_from_op}
\title{Igraph object from OmniPath network}
\usage{
graph_from_op(op_data)
}
\arguments{
\item{op_data}{Data frame (tibble) of OmniPath PPI interactions from
\code{\link{wppi_omnipath_data}}.}
}
\value{
Igraph PPI graph object with vertices defined by UniProt ID and
    Gene Symbol, and edges based on interactions, for all connections in
    OmniPath.
}
\description{
Creation of igraph object from PPI OmniPath database with information
regarding proteins and gene symbols.
}
\examples{
graph_op <- graph_from_op(wppi_omnipath_data())
edges_op <- igraph::E(graph_op)
vertices_op <- igraph::V(graph_op)

}
\seealso{
\code{\link{wppi_omnipath_data}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wppi.R
\docType{package}
\name{wppi}
\alias{wppi}
\title{The wppi package}
\description{
The \code{wppi} package calculates context specific scores for genes in
the network neighborhood of genes of interest. The context specificity
is ensured by the selection of the genes of interest and potentially by
using a more relevant subset of the ontology annotations, e.g. selecting
only the diabetes related categories. The PPI network and the functional
annotations are obtained automatically from public databases, though
it's possible to use custom databases. The network is limited to a
neighborhood of the genes of interest. The ontology annotations are also
filtered to the genes in this subnetwork. Then the adjacency matrix is
weighted according to the number of common neighbors and the similarity
in functional annotations of each pair of interacting proteins. On this
weighted adjacency matrix a random walk with restart is performed. The
final score for the genes in the neighborhood is the sum of their scores
(probabilities to be visited) in the random walk.
The method can be fine tuned by setting the neighborhood range, the
restart probability of the random walk and the threshold for the random
walk.
}
\examples{
# Example with a single call:
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
scores <- score_candidate_genes_from_PPI(genes_interest)
# The workflow step by step:
db <- wppi_data()
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
graph_op <- graph_from_op(db$omnipath)
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
w_adj <- weighted_adj(graph_op_1, db$go, db$hpo)
w_rw <- random_walk(w_adj)
scores <- prioritization_genes(graph_op_1, w_rw, genes_interest)

}
\author{
Ana Galhoz \email{ana.galhoz@helmholtz-muenchen.de} and
Denes Turei \email{turei.denes@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Annot_functions.R
\name{functional_annot}
\alias{functional_annot}
\title{Functional similarity score based on ontology}
\usage{
functional_annot(annot, gene_i, gene_j)
}
\arguments{
\item{annot}{Processed annotation data as provided by
\code{\link{process_annot}}.}

\item{gene_i}{String with the gene symbol in the row of the adjacency
matrix.}

\item{gene_j}{String with the gene symbol in the column of the adjacency
matrix.}
}
\value{
Numeric value with GO/HPO functional similarity between given
    pair of proteins.
}
\description{
Functional similarity between two genes in ontology databases (GO or HPO).
Each pair of interacting proteins in the PPI graph network, is
quantified the shared annotations between them using the Fisher's combined
probability test (\url{https://doi.org/10.1007/978-1-4612-4380-9_6}). This
is based on the number of genes annotated in each shared ontology term and
the total amount of unique genes available in the ontology database.
}
\examples{
hpo <- wppi_hpo_data()
hpo <- process_annot(hpo)
hpo_score <- functional_annot(hpo, 'AKT1', 'MTOR')
# [1] 106.9376

}
\seealso{
\itemize{
    \item{\code{\link{process_annot}}}
    \item{\code{\link{weighted_adj}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{weighted_adj}
\alias{weighted_adj}
\title{Weighted adjacency matrix}
\usage{
weighted_adj(graph_op, GO_data, HPO_data)
}
\arguments{
\item{graph_op}{Igraph object based on OmniPath PPI interactions from
\code{\link{graph_from_op}}.}

\item{GO_data}{Data frame with GO annotations as provided by
\code{\link{wppi_go_data}}.}

\item{HPO_data}{Data frame with HPO annotations as provided by
\code{\link{wppi_hpo_data}}.}
}
\value{
Weighted adjacency matrix based on network topology and functional
    similarity between interacting proteins/genes based on ontology
    databases.
}
\description{
Converts adjacency to weighted adjacency using network topology
information (shared neighbors between connected nodes via
\code{\link{common_neighbors}}) integrated with genome and phenotype
factors from GO and HPO annotation terms (functionality computed by
\code{\link{functional_annot}}). At the end, the weighted adjacency
matrix is normalized by column.
}
\examples{
db <- wppi_data()
GO_data <- db$go
HPO_data <- db$hpo
# Genes of interest
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
# Graph object with PPI 
graph_op <- graph_from_op(db$omnipath)
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
# Filter ontology data
GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
# Weighted adjacency
w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)

}
\seealso{
\itemize{
    \item{\code{\link{random_walk}}}
    \item{\code{\link{prioritization_genes}}}
    \item{\code{\link{common_neighbors}}}
    \item{\code{\link{graph_from_op}}}
    \item{\code{\link{subgraph_op}}}
    \item{\code{\link{score_candidate_genes_from_PPI}}}
    \item{\code{\link{wppi_go_data}}}
    \item{\code{\link{wppi_hpo_data}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_data.R
\name{wppi_hpo_data}
\alias{wppi_hpo_data}
\title{Retrieves data from Human Phenotype Ontology (HPO)}
\usage{
wppi_hpo_data()
}
\value{
A data frame (tibble) with HPO data.
}
\description{
Human Phenotype Ontology (\url{https://hpo.jax.org/app/}), HPO) annotates
proteins with phenotypes and diseases.
}
\examples{
hpo <- wppi_hpo_data()

}
\seealso{
\code{\link{wppi_data}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Annot_functions.R
\name{count_genes}
\alias{count_genes}
\title{Number of total genes in an ontology database}
\usage{
count_genes(data_annot)
}
\arguments{
\item{data_annot}{Data frame (tibble) of GO or HPO datasets from
\code{\link{wppi_go_data}} or \code{\link{wppi_hpo_data}}.}
}
\value{
Number of total unique genes in each ontology database.
}
\description{
Number of total genes in an ontology database
}
\examples{
go <- wppi_go_data()
count_genes(go)
# [1] 19712

}
\seealso{
\itemize{
    \item{\code{\link{wppi_go_data}}}
    \item{\code{\link{wppi_hpo_data}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{prioritization_genes}
\alias{prioritization_genes}
\title{Candidate genes prioritization}
\usage{
prioritization_genes(
  graph_op,
  prob_matrix,
  genes_interest,
  percentage_genes_ranked = 100
)
}
\arguments{
\item{graph_op}{Igraph object based on OmniPath PPI interactions from
\code{\link{graph_from_op}}.}

\item{prob_matrix}{Matrix object with correlations/probabilities of the
all nodes in the network from \code{\link{random_walk}}.}

\item{genes_interest}{Character vector with known-disease specific genes.}

\item{percentage_genes_ranked}{Positive integer (range between 0 and 100)
specifying the percentage (%) of the total candidate genes in the
network returned in the output. If not specified, the score of all the
candidate genes is delivered.}
}
\value{
Data frame with the ranked candidate genes based on the functional
    score inferred from given ontology terms, PPI and Random Walk with
    Restart parameters.
}
\description{
Ranks candidate genes based on correlation with the given seed
genes of interest. For this, the source proteins/genes (i.e. starting
nodes) are reduced to the candidate genes and the target proteins/genes
(i.e. end nodes) to the given genes of interest. Each candidate gene
score is defined by the sum of its correlations towards the known
disease-related genes.
}
\examples{
db <- wppi_data()
GO_data <- db$go
HPO_data <- db$hpo
# Genes of interest
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
# Graph object with PPI 
graph_op <- graph_from_op(db$omnipath)
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
# Filter ontology data
GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
# Weighted adjacency
w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)
# Random Walk with Restart
w_rw <- random_walk(w_adj)
# Ranked candidate genes
scores <- prioritization_genes(graph_op_1, w_rw, genes_interest)

}
\seealso{
\itemize{
    \item{\code{\link{graph_from_op}}}
    \item{\code{\link{weighted_adj}}}
    \item{\code{\link{random_walk}}}
    \item{\code{\link{score_candidate_genes_from_PPI}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/WPPI_functions.R
\name{random_walk}
\alias{random_walk}
\title{Random Walk with Restart (RWR)}
\usage{
random_walk(weighted_adj_matrix, restart_prob = 0.4, threshold = 1e-05)
}
\arguments{
\item{weighted_adj_matrix}{Matrix object corresponding to the weighted
adjacency from \code{\link{weighted_adj}}.}

\item{restart_prob}{Positive value between 0 and 1 defining the restart
probability parameter used in the RWR algorithm. If not specified, 0.4
is the default value.}

\item{threshold}{Positive value depicting the threshold parameter in the
RWR algorithm. When the error between probabilities is smaller than the
threshold defined, the algorithm stops. If not specified, 1e-5 is
the default value.}
}
\value{
Matrix of correlation/probabilities for the functional
    similarities for all proteins/genes in the network.
}
\description{
RWR on the normalized weighted adjacency matrix.
The RWR algorithm estimates each protein/gene relevance based on the
functional similarity of genes and disease/phenotype, and the topology
of the network. This similarity score between nodes measures how closely
two proteins/genes are related in a network. Thus, enabling to identify
which candidate genes are more related to our given genes of interest.
}
\examples{
db <- wppi_data()
GO_data <- db$go
HPO_data <- db$hpo
# Genes of interest
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
# Graph object with PPI 
graph_op <- graph_from_op(db$omnipath)
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
# Filter ontology data
GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)
HPO_data_filtered <- filter_annot_with_network(HPO_data, graph_op_1)
# Weighted adjacency
w_adj <- weighted_adj(graph_op_1, GO_data_filtered, HPO_data_filtered)
# Random Walk with Restart
w_rw <- random_walk(w_adj)

}
\seealso{
\itemize{
    \item{\code{\link{weighted_adj}}}
    \item{\code{\link{prioritization_genes}}}
    \item{\code{\link{score_candidate_genes_from_PPI}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Annot_functions.R
\name{filter_annot_with_network}
\alias{filter_annot_with_network}
\title{Filter ontology datasets using PPI network object}
\usage{
filter_annot_with_network(data_annot, graph_op)
}
\arguments{
\item{data_annot}{Data frame (tibble) of GO or HPO datasets from
\code{\link{wppi_go_data}} or \code{\link{wppi_hpo_data}}.}

\item{graph_op}{Igraph graph object obtained from built OmniPath PPI of
genes of interest and x-degree neighbors.}
}
\value{
Data frame (tibble) of GO or HPO datasets filtered based on
    proteins available in the igraph object.
}
\description{
Filter ontology datasets using PPI network object
}
\examples{
# Get GO database
GO_data <- wppi_go_data()
# Create igraph object based on genes of interest and first neighbors
genes_interest <-
    c("ERCC8", "AKT3", "NOL3", "GFI1B", "CDC25A", "TPX2", "SHE")
graph_op <- graph_from_op(wppi_omnipath_data())
graph_op_1 <- subgraph_op(graph_op, genes_interest, 1)
# Filter GO data
GO_data_filtered <- filter_annot_with_network(GO_data, graph_op_1)

}
\seealso{
\itemize{
    \item{\code{\link{wppi_go_data}}}
    \item{\code{\link{wppi_hpo_data}}}
    \item{\code{\link{graph_from_op}}}
}
}
